;; --------------------------------------------------------------------
;; HybridSAL
;; Copyright (C) 2006, SRI International.  All Rights Reserved.
;; 
;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License
;; as published by the Free Software Foundation; either version 2
;; of the License, or (at your option) any later version.
;; 
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;; 
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software
;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;; --------------------------------------------------------------------

(cl:defpackage "sal"
  (:export "file-exists-p"
   "defcl"				    ;; defcl.lisp
   "context" "context-name" "numeral"	    ;; sal-class-defns.lisp
   "sal-parse" "sal-error" "sal-parse-term" ;; sal-parse.lisp
   "typecheck*"
   "tc-eq" "typecheck" "typecheck-file"	    ;; sal-typecheck.lisp
   "ps-eq" "op2symbol" "args1" "args2" 
   "times-operator" "divides-operator"
   "disjuncts" "conjuncts"
   "real-atomic-fmla?" "bool-atomic-fmla?"
   "baf2boolvar" "baf2boolval" "baf2boolsgn"
   "binary?" "pvsexpr2RAFstrings"	    ;; sal-extension.lisp
   "expression" "application" "operator"
   "name-expr" "name-expr?" "this-number"
   "unparse"				    ;; sal-unparse.lisp
   "get-context" "id" "context-body" "declarations" "module"
   "module1" "module2" "mod-name" "mod-decl" "modref"
   "input-decls" "output-decls" "local-decls" "global-decls"
   "assignments" "name" "lhs" "rhs-definition" "mod-name" "type"
   "definitions-or-commands" "parameters" "declarations"
   "assertion" "assertion-form" "name" "expression" "exprs"
   "argument" "state-type" "sal-typecheck-term" ;; utility functions
   "global-decl?" "local-decl?" "input-decl?" "output-decl?"
   "name-expr?" "module-declaration?" "var-decl?" "invar-decl?"
   "def-decl?" "def-decl" "definitions"
   "initfor-decl?" "init-decl?" "trans-decl?" "guarded-command?"
   "assertion-declaration?" "expression?" "conditional?"
   "chained-conditional?" "simple-definition?"
   "infix?" "elsif?" "parens" 
   "module-declaration" "next-operator" "name-expr"	;; classes
   "synchronous-composition" "base-module" "guarded-command"
   "asynchronous-composition" "mk-sal-asynchronouscomposition"
   "module-instance"
   "var-decl" "invar-decl" "initfor-decl" "init-decl" "trans-decl"
   "guard" "infix-application" "conditional" "simple-definition"
   "mk-sal-context" "mk-sal-parameters" "mk-sal-contextbody" 
   "mk-sal-typedeclaration" "mk-sal-scalartype" "mk-sal-typename"
   "mk-sal-basemodule" "mk-sal-synchronouscomposition" 
   "mk-sal-moduleinstance" "mk-sal-modulename" 
   "mk-sal-modulemodels" "mk-sal-moduleinstance"
   "mk-sal-modulename" "mk-sal-moduleactuals" 
   "mk-sal-assertiondeclaration" "mk-sal-assertionform" 
   "mk-sal-transdecl" "mk-sal-somecommands" "mk-sal-initdecl"
   "mk-sal-scalarelement" "mk-sal-guardedcommand"  
   "mk-sal-simpledefinition" "mk-sal-rhsselection"
   "mk-sal-functiontype" "mk-sal-setlistexpression"
   "mk-sal-conditional" "mk-sal-constantdeclaration"
   "mk-sal-nextoperator" "mk-sal-guard" "mk-sal-assignments"
   "mk-sal-nameexpr"
   "mk-sal-tupleliteral" "mk-sal-application" 
   "mk-sal-vardecl" "mk-sal-globaldecl"
   "mk-sal-inputdecl" "mk-sal-outputdecl" "mk-sal-localdecl"
   "mk-sal-vardecls" "mk-sal-moduledeclaration" "mk-sal-defdecl"
   "AND" "OR" "NOT" "TRUE" "FALSE")
  (:import-from :excl "exit")
  (:use :cl :user :clos))

